﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.IntegerVector;

  public class NegativeToZero : BenchmarkSuiteDataDescriptor {
    private const string name = "Negative to Zero";
    private const string fileName = "NegativeToZero.csv";
    private const string description = "Given a vector of integers, return the vector where all negative integers have been replaced by 0.";

    protected override string FileName { get { return fileName; } }
    public override string Name { get { return name; } }
    public override string Description { get { return description; } }
    protected override int InputArgumentCount { get { return 1; } }
    protected override int OutputArgumentCount { get { return 1; } }

    public override ProblemData CreateProblemData() {
      return new ProblemData {
        Name = Name,
        Description = Description,
        Examples = CloneExamples(),
        BestResult = 0,
        WorstResult = 50000,
        InputArgumentTypes = new[] { ExampleArgumentType.IntegerVector },
        OutputArgumentTypes = new[] { ExampleArgumentType.IntegerVector },
        TrainingCount = 200,
        TestCount = 2000,
        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.IntegerVector,
        MaxSize = 500,
        EvalLimit = 1500,
        ErcOptions = {
          ErcProbability = 0.05,
          IntegerErcOptions = new IntegerErcOptions(
            new IntegerConstantErcValue(0)),
          IntegerVectorErcOptions = new IntegerVectorErcOptions(
            new IntegerVectorConstantsErcValue(new int[0]))
        }
      };
    }

    protected override Example ParseExample(string[] input, string[] output) {
      return new Example {
        InputArgs = input,
        OutputArgs = output,
        InputIntegerVector = new[] { ExampleArgumentConverter.ConvertIntegers(input[0]) },
        OutputIntegerVector = new[] { ExampleArgumentConverter.ConvertIntegers(output[0]) },
      };
    }
  }
}
